<template>
  <div
    :class="[
      styles.icon,
      styles[`${size}Size`]
    ]"
  >
    <component
      :is="component"
      :class="styles.source"
    />
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import styles from './icon.module.scss';

const sizes = ['xs', 'sm', 'md', 'lg', 'xl'];
const types = ['xs', 'sm', 'md', 'lg', 'xl'];

@Component({
  name: 'Icon',
  data: () => ({ styles }),
})
export default class Icon extends Vue {
  @Prop({ default: () => 'sm' })
  size?: typeof sizes[number]

  @Prop()
  type!: typeof types[number]

  get component() {
    return require(`./assets/${this.type}.inline.svg`).default;
  }
}
</script>
